/*
sudoku - Create and play sudoku

Copyright (C) 2006 Sven Heinzel <Sven.Heinzel@gmx.net>
 
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "sudoku.h"
#include "MainDialog.h"
#include "FieldView.h"

MainDialog::MainDialog(
    QWidget     *pParent,
    Qt::WFlags  flags
)
    :
    QDialog( pParent, flags )
{
    setupUi( this );

    Init();
}

MainDialog::~MainDialog()
{
}

void MainDialog::Init()
{
    FieldView       *p_field = new FieldView( mpFrameField );
    QHBoxLayout     *p_layout = new QHBoxLayout( mpFrameField );

    if ( p_layout && p_field )
    {
        p_layout -> setMargin( 0 );
        p_layout -> addWidget( p_field );

        // FIXME
        // Connect to FieldView functions

        connect( mpButtonSave, SIGNAL( clicked() ), p_field, SLOT( Save() ) );
        connect( mpButtonLoad, SIGNAL( clicked() ), p_field, SLOT( Load() ) );
        connect( mpButtonGenerate, SIGNAL( clicked() ), p_field, SLOT( Generate() ) );
        connect( mpButtonEdit, SIGNAL( toggled( bool ) ), p_field, SLOT( SetEditMode( bool ) ) );
        connect( mpButtonEdit, SIGNAL( toggled( bool ) ), mpButtonSolveOne, SLOT( setDisabled( bool ) ) );
        connect( mpButtonEdit, SIGNAL( toggled( bool ) ), mpButtonSolveAll, SLOT( setDisabled( bool ) ) );
        connect( mpButtonHelp, SIGNAL( toggled( bool ) ), p_field, SLOT( SetHelpMode( bool ) ) );
        connect( p_field, SIGNAL( HelpModeChanged( bool ) ), mpButtonHelp, SLOT( setChecked( bool ) ) );
        connect( mpButtonReset, SIGNAL( clicked() ), p_field, SLOT( ResetField() ) );
        connect( mpButtonSolveOne, SIGNAL( clicked() ), p_field, SLOT( SolveOne() ) );
        connect( mpButtonSolveAll, SIGNAL( clicked() ), p_field, SLOT( SolveAll() ) );
        connect( mpButtonAbout, SIGNAL( clicked() ), p_field, SLOT( About() ) );
    }
}
