/*
sudoku - Create and play sudoku

Copyright (C) 2007 Sven Heinzel <Sven.Heinzel@gmx.net>
 
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#pragma once

#ifndef EXPORTWIDGET_H
#define EXPORTWIDGET_H

#include "sudoku_gui.h"
#include "ExportOptions.h"

class ExportWidget : public QWidget
{
    Q_OBJECT

public:
    explicit ExportWidget( ExportOptions const  &rOptions, QWidget  *pParent = 0, Qt::WindowFlags  flags = 0 );
    virtual ~ExportWidget();

    void SetExportOptions( ExportOptions const  &/*rOptions*/ )
    {
        /*
        mpComboType -> setCurrentIndex( mpComboType -> findData( rOptions . GetType() ) );
        mpSliderCount -> setValue( rOptions . GetFixedFields() );
        mpCheckSymmetric -> setChecked( rOptions . IsSymmetric() );
        */
    }

    ExportOptions GetExportOptions() const
    {
        return ExportOptions( /*static_cast< ExportOptions::Type >( mpComboType -> itemData( mpComboType -> currentIndex() ) . toInt() ),
                                mpSliderCount -> value(),
                                mpCheckSymmetric -> isChecked()*/ );
    }

private slots:

private:
    ExportOptions  mExportOptions;
    QFrame  *mpFrameSettings;
    QFrame  *mpFramePreview;
    QComboBox  *mpComboType;
    QGroupBox  *mpGroupCanvas;
    QLineEdit  *mpEditCanvasWidth;
    QLineEdit  *mpEditCanvasHeight;
    QComboBox  *mpComboCanvasAlignH;
    QComboBox  *mpComboCanvasAlignV;
    QGroupBox  *mpGroupGrid;
    QLineEdit  *mpEditGridSize;
    QCheckBox  *mpCheckFieldFixed;
    QCheckBox  *mpCheckFieldNonFixed;
    QCheckBox  *mpCheckFieldAllowed;
};

#endif
