/*
sudoku - Create and play sudoku

Copyright (C) 2007 Sven Heinzel <Sven.Heinzel@gmx.net>
 
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "sudoku_gui.h"
#include "GenerateDialog.h"

GenerateDialog::GenerateDialog(
    Sudoku::GenerateOptions const  &rOptions,
    QWidget                        *pParent,
    Qt::WindowFlags                flags
)
    : QDialog( pParent, flags )
    , mpGenerateWidget( 0 )
{
    setWindowTitle( tr( "Generate" ) );
    mpGenerateWidget = new GenerateWidget( rOptions, this );
    QDialogButtonBox  *p_button_box = new QDialogButtonBox( this );
    QPushButton  *p_ok = p_button_box -> addButton( QDialogButtonBox::Ok );
    QPushButton  *p_cancel = p_button_box -> addButton( QDialogButtonBox::Cancel );

    QVBoxLayout  *p_layout = new QVBoxLayout( this );
    p_layout -> addWidget( mpGenerateWidget );
    p_layout -> addStretch( 1 );
    p_layout -> addWidget( p_button_box );

    connect( p_ok, SIGNAL( clicked() ), SLOT( accept() ) );
    connect( p_cancel, SIGNAL( clicked() ), SLOT( reject() ) );
}

GenerateDialog::~GenerateDialog()
{
}
