/*
sudoku - Create and play sudoku

Copyright (C) 2007 Sven Heinzel <Sven.Heinzel@gmx.net>
 
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "sudoku_gui.h"
#include "sudoku_main.h"
#include "MainWindow.h"

int main(
    int     argc,
    char    *argv[]
)
{
    QApplication  app( argc, argv );

    // Load and install translators
    QTranslator  trans_qt, trans_sudoku;
    QString const  locale( QLocale::system() . name() );
    if( locale != "en_EN" ) {
        if( trans_qt . load( "i18n/qt_" + locale ) ) qApp -> installTranslator( &trans_qt );
        if( trans_sudoku . load( "i18n/sudoku." + locale ) ) qApp -> installTranslator( &trans_sudoku );
    }

    // Random seed and program icon
    srand( static_cast< unsigned int >( time( 0 ) ) );
    app . setWindowIcon( QIcon( ":/data/sudoku.png" ) );

    // Create and show main window
    MainWindow  main_window;
    main_window . show();

    // Return application exit code
    return app . exec();
}
