/*
sudoku - Create and play sudoku

Copyright (C) 2007 Sven Heinzel <Sven.Heinzel@gmx.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "sudoku/sudoku.h"
#include "sudoku/Generator.h"

namespace Sudoku {

bool Generator::Generate( Grid  &rGrid ) const
{
    Generator::Instance  instance( mGenerateOptions, rGrid );

    switch( mGenerateOptions . GetType() ) {
        case GenerateOptions::GenerateEmpty:
            // Just reset grid
            rGrid . Reset();
            return true;

        case GenerateOptions::GenerateFields:
            // Generate a new Grid
            return instance . Generate();

        case GenerateOptions::FillFixedFields:
            // Fill all fixed fields and reset everything else
            return false; // Unsupported

        default:
            ; // Unknown
    }
    return false;
}

}
