@echo off

SETLOCAL

echo Signing files...
signtool sign /v /sha1 %CODESIGNSHA1% /t http://time.certum.pl/ gui\compile\release\sudoku.exe

echo Building setup...
mkdir dist
FOR /F %%i IN ('perl scripts\version.pl libs\sudoku\include\sudoku\sudoku_version.h short') DO SET SUDOKU_VERSION=%%i
FOR %%i IN (g++.exe) DO SET GCCPATH=%%~dp$PATH:i
makensis /DSUDOKU_VERSION=%SUDOKU_VERSION% /DGCCPATH=%GCCPATH% install\windows\sudoku.nsi
rem Sleep 5 seconds to be sure file handle of the installer is released
ping 127.0.0.1 -n 5 > NUL
echo finished!

echo Signing installer...
signtool sign /v /sha1 %CODESIGNSHA1% /t http://time.certum.pl/ dist\*.exe

ENDLOCAL
